Author: bdrewery
Date: Thu Sep 12 18:44:48 2019
New Revision: 352261
URL: https://svnweb.freebsd.org/changeset/base/352261

Log:
  mtree: Fix -f -f not considering type changes.
  
  This only lists the changed type and not other attributes so that it
  matches the behavior of -C as done in r66747 for fmtree. The NetBSD
  -ff implementation was copied from fmtree.
  
  Reviewed by:  imp
  MFC after:    2 weeks
  Relnotes:     yes
  Differential Revision:        https://reviews.freebsd.org/D21623

Modified:
  head/contrib/mtree/specspec.c
  head/contrib/netbsd-tests/usr.sbin/mtree/t_mtree.sh
  head/usr.sbin/fmtree/specspec.c

Modified: head/contrib/mtree/specspec.c
==============================================================================
--- head/contrib/mtree/specspec.c       Thu Sep 12 18:37:26 2019        
(r352260)
+++ head/contrib/mtree/specspec.c       Thu Sep 12 18:44:48 2019        
(r352261)
@@ -145,7 +145,7 @@ compare_nodes(NODE *n1, NODE *n2, char const *path)
                return (1);
        }
        if (n1->type != n2->type) {
-               differs = 0;
+               differs = F_TYPE;
                mismatch(n1, n2, differs, path);
                return (1);
        }

Modified: head/contrib/netbsd-tests/usr.sbin/mtree/t_mtree.sh
==============================================================================
--- head/contrib/netbsd-tests/usr.sbin/mtree/t_mtree.sh Thu Sep 12 18:37:26 
2019        (r352260)
+++ head/contrib/netbsd-tests/usr.sbin/mtree/t_mtree.sh Thu Sep 12 18:44:48 
2019        (r352261)
@@ -411,7 +411,42 @@ netbsd6_nonemptydir_body() 
        FLAVOR=netbsd6 nonemptydir_body
 }
 
+atf_test_case mtree_specspec_type
+mtree_specspec_type_head()
+{
+       atf_set "descr" "Test that spec comparisons detect type changes"
+}
 
+mtree_specspec_type_body()
+{
+       mkdir testdir
+
+       touch testdir/bar
+       mtree -c -p testdir > mtree1.spec
+
+       if [ ! -f mtree1.spec ]; then
+               atf_fail "mtree failed"
+       fi
+
+       rm -f testdir/bar
+       ln -s foo testdir/bar
+       # uid change is expected to be ignored as done in -C
+       chown -h operator testdir/bar
+       mtree -c -p testdir > mtree2.spec
+
+       if [ ! -f mtree2.spec ]; then
+               atf_fail "mtree failed"
+       fi
+
+       atf_check -s ignore -o save:output \
+           -x "mtree -f mtree1.spec -f mtree2.spec"
+
+       if ! cut -f 3 output | egrep -q "bar file" || \
+           ! cut -f 3 output | egrep -q "bar link"; then
+               atf_fail "mtree did not detect type change"
+       fi
+}
+
 atf_init_test_cases()
 {
        atf_add_test_case mtree_create
@@ -423,6 +458,7 @@ atf_init_test_cases()
        atf_add_test_case mtree_ignore
        atf_add_test_case mtree_merge
        atf_add_test_case mtree_nonemptydir
+       atf_add_test_case mtree_specspec_type
 
        atf_add_test_case netbsd6_create
        atf_add_test_case netbsd6_check

Modified: head/usr.sbin/fmtree/specspec.c
==============================================================================
--- head/usr.sbin/fmtree/specspec.c     Thu Sep 12 18:37:26 2019        
(r352260)
+++ head/usr.sbin/fmtree/specspec.c     Thu Sep 12 18:44:48 2019        
(r352261)
@@ -132,7 +132,7 @@ compare_nodes(NODE *n1, NODE *n2, char const *path)
                return (1);
        }
        if (n1->type != n2->type) {
-               differs = 0;
+               differs = F_TYPE;
                mismatch(n1, n2, differs, path);
                return (1);
        }
_______________________________________________
svn-src-head@freebsd.org mailing list
https://lists.freebsd.org/mailman/listinfo/svn-src-head
To unsubscribe, send any mail to "svn-src-head-unsubscr...@freebsd.org"

Reply via email to